;;; Compute pi
(define (expt b n)
  (let expt-3 ((b b) (n n) (val 1))
    (if (zero? n) val (expt-3 b (- n 1) (* b val)))))

(define (truncate-log b n) ; = truncate(log_b(n))
  (let truncate-log-3 ((b b) (n n) (val 0))
    (if (< n b) val (truncate-log-3 b (quotient n b) (+ 1 val)))))

(define (partial-sum i n e ee base)
  (- (quotient base (* i e))
     (quotient base (* (+ 2 i) ee))))

(define (a n base)  ; atan(1/n)
  (do ((i 1 (+ 4 i))
       (delta 1 (partial-sum i n e (* e n n) base))
       (e n (* e n n n n))
       (sum 0 (+ sum delta)))
      ((zero? delta) sum)))

(define (calc-pi base)
  (- (* 32 (a  10 base))
     (* 16 (a 515 base))
     (*  4 (a 239 base))))

(define (run)
  (display "How many digits of pi do you want: ")
  (let ((num (read)))
    (if (and (integer? num) (positive? num))
      (let* ((extra (+ 5 (truncate-log 10 num))) ; was (extra (+ 5 (truncate (log num))))
               (base (expt 10 (+ num extra)))
               (pi (calc-pi base)))
        (display (quotient pi base))
        (display ".")
        (display (quotient (remainder pi base) (expt 10 extra)))
        (newline)))))

(run)
