/*
 * amscm.c
 *
 * This file is part of AM-Scheme.
 * AM-Scheme is coded by Atsushi Moriwaki
 *
 * This software is completely free to copy and distribute modifed version.
 * But I would appreciate it if you left my name on the code as the author.
 *
 */

#include "amscm.h"

/* We use 4 registers. */
pointer envir;      /* register for current environment */
pointer code;       /* register for current code */
pointer *stack;     /* register for stack */
pointer *stackbottom;
pointer *stacktop;
pointer *args;      /* register for argument of function */
long    nargs;

/*
   < Structure of stacks >
 
   -------------
  |args[nargs-1]| -
   -------------   |
  |             |  |
  .             .  |
  .             .  |<- function arguments
  .             .  |
  |             |  |
   -------------   |
  |   args[1]   | -
   -------------
  |   args[0]   | <- op value
   -------------
  |    NULL     |
   -------------
  |             | <- continuation stack top
   -------------
*/

pointer NIL;        /* special cell representing empty cell */
pointer T;          /* special cell representing #t */
pointer F;          /* special cell representing #f */
pointer eof_object; /* special cell representing eof-object */
pointer oblist[HASHTABLESIZE];  /* symbol table */
pointer global_env; /* pointer to global environment */

/* global pointers to special symbols */
pointer LAMBDA;     /* pointer to syntax lambda */
pointer QUOTE;      /* pointer to syntax quote */
pointer QQUOTE;     /* pointer to symbol quasiquote */
pointer UNQUOTE;    /* pointer to symbol unquote */
pointer UNQUOTESP;  /* pointer to symbol unquote-splicing */
pointer APPLY_ARRAY; /* pointer to symbol => */
pointer RESET_PATCH;/* pointer to symbol -*-reset-patch-*- */

char gc_verbose;    /* if gc_verbose is not zero, print gc status */

struct _char_cell char_table[CHARMAX];

pointer std_input;
pointer cur_input;
pointer std_output;
pointer cur_output;

pointer ld_file_list[MAXFILE];
int load_files = 0;
pointer i_port_list[MAXFILE];
int input_ports = 0;
pointer o_port_list[MAXFILE];
int output_ports = 0;

char strbuff[LINESIZE];
char identString[] = "@(#)amscm.c  1.07 92/03/17 created by Akira Kida";

#ifdef	MSDOS
int	_stacklen = 0xd400;
#endif
