/*
 * config.h
 *
 * This file is part of AM-Scheme.
 * AM-Scheme is coded by Atsushi Moriwaki
 *
 * This software is completely free to copy and distribute modifed version.
 * But I would appreciate it if you left my name on the code as the author.
 */
 
/*
 * Here is System declaration
 */
/* #define THINK_C     /* THINK C version 4.0 for Macintosh */
/* #define THINK_C_DA  /* THINK C version 4.0 for Macintosh DA */
/* #define MPW    /* Macintosh Programmer's Workshop */
/* #define BSD    /* 4.x BSD */
/* #define SYSV   /* System V */
/* #define VAXC	  /* VAX/VMS -- defined by CC automagically (by Akira Kida) */
/* #define MSDOS  /* MS-DOS + MS-C6 (by Akira Kida) */


/*
 * On some architecture, `dobule' requires double-word alignment.
 * (for instance SPARC). Define this in such a case.
 */
/* #define DOUBLEALIGN  /* Plase define this if `double' needs alignment */

/* #define VERBOSE /* If you like verbose GC, define this */
/* #define USE_OLD_CONDITIONAL_VALUE */
#define USE_SIGNAL

#ifndef THINK_C_DA
# include <stdio.h>
#endif
#include <ctype.h>
#include <setjmp.h>
#include <math.h>

#ifdef	MSDOS
# define LOADDS _loadds
#else
# define LOADDS
#endif

#define LINESIZE        1024  /* size of input line buffer */
#define HASHTABLESIZE    256  /* size of hash table */
#define MAXFILE           10  /* max # of open files */
#define OP_MAXNUM       1000  /* max # of eval_operators */

/* 
 *  standard charcter case is lower if STDCHARCASE is negative
 *  standard charcter case is upper if STDCHARCASE is potive
 *  standard charcter case is nothing if STDCHARCASE is zero
 */
#define STDCHARCASE (-1)

#define Banner "Hello, This is AM-Scheme Interpreter Version 1.10\n"
#define GoodBye "Good Luck!!\n"

/* System dependency */
#ifdef THINK_C
#ifdef THINK_C_DA
# define SCREENHEIGHT        40 /* maximum screen height */
# define SCREENWIDTH        100 /* maximum screen width */
# define EVALCOUNT           20 /* maximum number of Eval Cycle */
#else
# define prompt "> "
#endif
#include <string.h>
#include <stdlib.h>
#ifndef THIHK_C_DA
# ifdef USE_SIGNAL
#  include <signal.h>
# endif
#endif
#define ALIGNMENT sizeof(int)            /* alignment of memory */
#define InitFileName "amscm.scm"
#define MALLOCTYPE unsigned long
#define malloc NewPtr
#define free DisposPtr
#define DEFAULT_STORE_SIZE    100000  /* size of one of main memory area */
#define DEFAULT_STACK_SIZE      5000  /* size of stack */
#define DEFAULT_READ_STACK_SIZE 1000  /* size of reading stack */
#endif

#ifdef BSD
#include <strings.h>
#ifdef USE_SIGNAL
# include <signal.h>
#endif
#ifdef DOUBLEALIGN
# define ALIGNMENT sizeof(double)
#else
# define ALIGNMENT sizeof(char*)            /* alignment of memory */
#endif
#define InitFileName "/usr/local/lib/amscm.scm"
#define prompt "> "
#define MALLOCTYPE unsigned int
#define	memcpy(dst, src, len)	bcopy((src), (dst), (len))
#endif

#ifdef SYSV
#include <string.h>
#ifdef USE_SIGNAL
#include <signal.h>
#endif
#ifdef DOUBLEALIGN
# define ALIGNMENT sizeof(double)
#else
# define ALIGNMENT sizeof(char*)            /* alignment of memory */
#endif
#define InitFileName "/usr/local/lib/amscm.scm"
#define prompt "> "
#define MALLOCTYPE unsigned int
#endif

#ifdef MSDOS
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <malloc.h>
#include <dos.h>
#ifdef USE_SIGNAL
# include <signal.h>
#endif
#define ALIGNMENT sizeof(int)            /* alignment of memory */
#define InitFileName "amscm.scm"
#define prompt "> "
#define MALLOCTYPE unsigned int
#define DEFAULT_STORE_SIZE     64000  /* size of one of main memory area */
#define DEFAULT_STACK_SIZE      5000  /* size of stack */
#define DEFAULT_READ_STACK_SIZE 1000  /* size of reading stack */
/*
 * Note following recursive #define is allowd only in ANSI-C.
 * However, since all the state of the art compilers for DOS are
 * now ANSI conformant, this may be Ok.
 */
#define	memcpy(dst, src, len)	memcpy((dst), (src), (size_t)(len))
#endif

#ifdef MPW
#include <strings.h>
#undef USE_SIGNAL
#define ALIGNMENT sizeof(char*)            /* alignment of memory */
#define InitFileName "amscm.scm"
#define prompt "> input next line\n"
#define MALLOCTYPE unsigned int
#define DEFAULT_STORE_SIZE    100000  /* size of one of main memory area */
#define DEFAULT_STACK_SIZE      5000  /* size of stack */
#define DEFAULT_READ_STACK_SIZE 1000  /* size of reading stack */
#endif

#ifdef	VAXC
#include <string.h>
#ifdef USE_SIGNAL
#include <signal.h>
#endif
#define ALIGNMENT sizeof(char*)            /* alignment of memory */
#define InitFileName "sys$login:amscm.scm"
#define prompt "> "
#define MALLOCTYPE unsigned int
#endif

#define MALLOCCAST(xxx) (MALLOCTYPE)(xxx)

#ifndef DEFAULT_STORE_SIZE
#define DEFAULT_STORE_SIZE    300000  /* size of one of main memory area */
#define DEFAULT_STACK_SIZE     10000  /* size of stack */
#define DEFAULT_READ_STACK_SIZE 2000  /* size of reading stack */
#endif
