/*
 * error.c
 *
 * This file is part of AM-Scheme.
 * AM-Scheme is coded by Atsushi Moriwaki
 *
 * This software is completely free to copy and distribute modifed version.
 * But I would appreciate it if you left my name on the code as the author.
 *
 */
 
#include "amscm.h"

jmp_buf reset_jmp;

/* ========== Error ==========  */

FatalError(fmt, a, b, c)
char *fmt, *a, *b, *c;
{
    strcpy(&strbuff[0], "Fatal error: ");
    PrintString(std_output, &strbuff[0]);
    sprintf(&strbuff[0], fmt, a, b, c);
    PrintString(std_output, &strbuff[0]);
    PrintChar(std_output, '\n');
    longjmp(reset_jmp, 2);
}

Error(fmt, a, b, c)
char *fmt, *a, *b, *c;
{
    strcpy(&strbuff[0], "Error: ");
    PrintString(std_output, &strbuff[0]);
    sprintf(&strbuff[0], fmt, a, b, c);
    PrintString(std_output, &strbuff[0]);
    reset();
}

reset()
{
    pointer x;
    extern char linebuff[];
#ifdef THINK_C_DA
    extern int verbose_eval;
#endif

    /* fisrt do (-*-rset-patch-*-) */
    for (x = car(global_env); x != NIL ; x = cdr(x)) {
        if (caar(x) == RESET_PATCH) break;
    }
    if (x != NIL) {
        n_gc_protect = 0;
        stack = stackbottom - 1;
        envir = global_env;
        s_save(OP_EVALEND, NIL)
        s_push(NULL) s_push(cdar(x))
        args = stack;
        nargs = 1;
#ifndef THINK_C_DA
        Eval_Cycle(OP_APPLY);
#else
        verbose_eval = 0;
        eval_operator = OP_APPLY;
        Eval_Cycle();
        verbose_eval = 1;
#endif
    }
    
    reset_load();
    stack = stackbottom - 1;
    envir = global_env;
    code = NIL;
    r_value = NIL;
    n_gc_protect = 0;
    Is_read_complete = 0;
    cur_input = std_input;
    cur_output = std_output;
    clear_inputline(std_input)
    Init_read_stack()
    PrintString(std_output, "\n[return to toplevel]\n");
    reset_os_depend();
    longjmp(reset_jmp, 1);
}
