/*
 * op.h
 *
 * This file is part of AM-Scheme.
 * AM-Scheme is coded by Atsushi Moriwaki
 *
 * This software is completely free to copy and distribute modifed version.
 * But I would appreciate it if you left my name on the code as the author.
 *
 */
/*
 * This file is totally rewritten by Akira Kida
 */
/* operator code */
typedef int	op_type;
#define OP_EVALEND	0
#define OP_EVAL		1
#define OP_E0ARGS	2
#define OP_E1ARGS	3
#define OP_E2ARGS	4
#define OP_E3ARGS 	5
#define OP_APPLY	6
#define OP_DOMACRO	7
#define OP_LAMBDA	8
#define OP_QUOTE	9
#define OP_DEF0		10
#define OP_DEF1		11
#define OP_GDEF0	12
#define OP_GDEF1	13
#define OP_BEGIN	14
#define OP_IF0		15
#define OP_IF1		16
#define OP_SET0		17
#define OP_SET1		18
#define OP_SET2		19
#define OP_COND0	20
#define OP_COND1	21
#define OP_COND2	22
#define OP_MAC0		23
#define OP_MAC1		24
#define OP_GMAC0	25
#define OP_GMAC1	26
#define OP_AND0		27
#define OP_AND1		28
#define OP_OR0		29
#define OP_OR1		30
#define OP_LET0		31
#define OP_LET1		32
#define OP_LET2		33
#define OP_LAST0	34
#define OP_LAST1	35
#define OP_LAST2	36
#define OP_LREC0	37
#define OP_LREC1	38
#define OP_CASE0	39
#define OP_CASE1	40
#define OP_CASE2	41
#define OP_PRIMEVAL	42
#define OP_PRIMAPPLY	43
#define OP_CONTINUATION	44
#define OP_LOAD		45
#define OP_READ		46
#define OP_READ1	47
#define OP_RCHR		48
#define OP_RCHR1	49
#define OP_PKCH		50
#define OP_PKCH1	51
#define OP_PRBEGIN	52
#define OP_PREND	53
#define OP_PRLST	54
#define OP_PRCDR	55
#define OP_PRVEC	56
#define OP_PRBOX	57

#if OP_PRBOX > OP_MAXNUM
  OP_MAXNUM too small --- this shall cause fatal compilation error.
#endif

typedef int	num_op_type;
#define OP_ADD		0
#define OP_SUB		1
#define OP_MUL		2
#define OP_DIV		3
#define OP_REM		4
#define OP_MOD		5
#define OP_QUO		6
#define OP_NEQ		7
#define OP_LESS		8
#define OP_GRE		9
#define OP_LEQ		10
#define OP_GEQ		11
#define OP_ABS		12
#define OP_MAX		13
#define OP_MIN		14
#define OP_EXPT		15
#define OP_ZEROP	16
#define OP_POSP		17
#define OP_NEGP		18
#define OP_EVEN		19
#define OP_ODD		20
#define OP_EXP		21
#define OP_LOG		22
#define OP_SIN		23
#define OP_COS		24
#define OP_TAN		25
#define OP_ASIN		26
#define OP_ACOS		27
#define OP_ATAN		28
#define OP_SQRT		29
#define OP_FLOOR	30
#define OP_CEIL		31
#define OP_TRUN		32
#define OP_ROUND	33


typedef int	tok_type;
#define TOK_EOL		0
#define TOK_LPAREN	1
#define TOK_RPAREN	2
#define TOK_DOT		3
#define TOK_VECTOR	4
#define TOK_ATOM	5
#define TOK_QUOTE	6
#define TOK_DQUOTE	7
#define TOK_BQUOTE	8
#define TOK_COMMA	9
#define TOK_ATMARK	10
#define TOK_SHARP	11
#define TOK_EOF		12

typedef int	read_op_type;
#define OP_RDEND	0
#define OP_RDLST	1
#define OP_RDDOT	2
#define OP_RDVEC	3
#define OP_RDQUT	4
#define OP_RDQQ		5
#define OP_RDUQ		6
#define OP_RDUQSP	7
